#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include "drzewo.h"

/* 
 * ===  FUNCTION  ======================================================================
 *         Name:  add
 *  Description:  Dodaje 'word' do drzewa (galezi) wskazanego przez 'd' umieszczajac je
 *  w porzadku alfabetycznym. Wartoscia zwracana jest adres drzewa (wezla) po aktualizacji 
 *  jego zawartosci. 
 * =====================================================================================
 */
struct tree* add(struct tree *d,char *word)
{
	struct tree *wezel=NULL;
	if(!d)
	{
		// tworzenie nowego wezla wezel;
		if((wezel=(struct tree*)malloc(sizeof(struct tree)))==NULL) return NULL;
		else
		{
			wezel->word=strdup(word);
			wezel->count=1;
			wezel->left=wezel->right=NULL;
		}
		return wezel;
	}
	if(strcmp(d->word,word)==0)      
	{
		d->count++;
		return d;
	}
	if(strcmp(d->word,word)>0) d->left=add(d->left,word);
	else d->right=add(d->right,word);

	return d;
}

/* 
 * ===  FUNCTION  ======================================================================
 *         Name:  print
 *  Description: Wyswietla zawartosc drzewa (galezi) poczynajac od najbardziej skrajnego 
 *  lewego wezla do najdalszego wezla na prawo. Wyswietlana jest lista slow w porzadku 
 *  alfabetycznym i count  wystapien slow w drzewie.
 * =====================================================================================
 */
void print(struct tree *d)
{
	if(!d) return ;
	print(d->left);
	printf("%20s %d\n",d->word,d->count);
	print(d->right);
	
}

/* 
 * ===  FUNCTION  ======================================================================
 *         Name:  free_tree
 *  Description:  Usuwa z pamieci strukture drzewa.
 * =====================================================================================
 */
void free_tree(struct tree *d)
{
   if(d)
   {
     free_tree(d->left);
     d->left = NULL;

     free_tree(d->right);
	  d->right = NULL;

	  free(d->word);
	  free(d);
   }
}
